package com.sfeir.gwt.webding.client.component;

import java.util.LinkedHashMap;
import java.util.Map;

import com.google.gwt.user.client.Timer;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.DecoratedPopupPanel;
import com.google.gwt.user.client.ui.Label;

/**
 * Affiche un message dans le coin inférieur droite, en empilant les messages.
 * Le message est affiché pendant 5 secondes
 * 
 * @author sfeir
 */
public class Info extends DecoratedPopupPanel {
    /**
     * Affiche le message donne
     * 
     * @param text Le message a affiche
     */
    public static void display(String text) {
        final Info popupInfo = new Info(text);
        popupInfo.show();
    }

    /**
     * Cree un nouveau message et l'affiche
     * @param text
     */
    private Info(String text) {
        super();
        setAnimationEnabled(true);
        setWidget(new Label(text));
        setPopupPositionAndShow(new PositionCallback() {
            public void setPosition(int offsetWidth, int offsetHeight) {
                int width = Window.getClientWidth();
                int height = Window.getClientHeight();
                int left = width - offsetWidth - 10;
                int top = height - getTop(Info.this, offsetHeight);
                setPopupPosition(left, top);
                //setPopupPosition(0, 0);
                //show();
                Timer t = new Timer() {
                    public void run() {
                        hide();
                        listeHeight.remove(Info.this);
                    }
                  };
                t.schedule(5000);
                
            }
        });
    }
    
    protected static Map<Info,Integer> listeHeight = new LinkedHashMap<Info, Integer>();
    
    /**
     * Retourne la hauteur où placer le nouveau message en additionnant les hauteurs des précédents messages
     * 
     * @param info Popup Message à afficher
     * @param offsetHeight Hauteur de message à afficher
     * @return
     */
    protected static Integer getTop(Info info, int offsetHeight) {
        int h = offsetHeight + 10;
        for (Integer wh : listeHeight.values()) {
            h += wh + 10;
        }
        listeHeight.put(info, offsetHeight);
        return h;
    }
}
